/*
 * pwm.c
 *
 *  Created on: Apr 23, 2012
 *      Author: Dingo
 */
#include "../FreeRTOS/FreeRTOS.h"
#include "../System/lpc214x.h"
#include "pwm.h"



void pwm_init(){
	PCONP |= (1<<5); //Enable power to PWM0
	PINSEL0 |= (1<<15);//Set P0.7 for PWM

	PWMTCR = PWM_TCR_CR;
    PWMMCR = PWM_MCR_MR0R;    //Reset Timer Count on Match 0

    PWMMR0=0xFF;
    PWMMR2=0x80;     //Set Match Register to 1
    PWMLER = PWM_LER_M2L | PWM_LER_M0L;
    PWMPCR=PWM_PCR_ENA2;     //Enable PWM2 for output
	PWMTCR = (PWM_TCR_CE | PWM_TCR_PWME);  		   //Counter and PWM Enable
}

void pwm_set(unsigned int ch, unsigned int val){
	PWMMR0=MAX_CYCLE_TIME;
	PWMMR2=val; //Change Match 2 to updated value
	PWMLER = PWM_LER_M0L | PWM_LER_M2L; //Enable Latch for Load
	//PWMTCR = PWM_TCR_CR;
}

