/*
 * tlc5940.c
 *
 *  Created on: May 10, 2012
 */
#include "../FreeRTOS/FreeRTOS.h"
#include "../System/lpc214x.h"
#include "tlc5940.h"


#define TLC5940_N 1


uint8_t dcData[96 * TLC5940_N] = {
// MSB LSB
	1, 1, 1, 1, 1, 1, // Channel 15
	1, 1, 1, 1, 1, 1, // Channel 14
	1, 1, 1, 1, 1, 1, // Channel 13
	1, 1, 1, 1, 1, 1, // Channel 12
	1, 1, 1, 1, 1, 1, // Channel 11
	1, 1, 1, 1, 1, 1, // Channel 10
	1, 1, 1, 1, 1, 1, // Channel 9
	1, 1, 1, 1, 1, 1, // Channel 8
	1, 1, 1, 1, 1, 1, // Channel 7
	1, 1, 1, 1, 1, 1, // Channel 6
	1, 1, 1, 1, 1, 1, // Channel 5
	1, 1, 1, 1, 1, 1, // Channel 4
	1, 1, 1, 1, 1, 1, // Channel 3
	1, 1, 1, 1, 1, 1, // Channel 2
	1, 1, 1, 1, 1, 1, // Channel 1
	1, 1, 1, 1, 1, 1, // Channel 0
};


uint16_t gsData[16] = {0};



void tlc5940_init(){
	CONFIG_GSCLK();
	CLR_GSCLK();

	CONFIG_SCLK();
	CLR_SCLK();

	CONFIG_XLAT();
	CLR_XLAT();

	CONFIG_BLANK();
	SET_BLANK();

	CONFIG_SDIN();
	CLR_SDIN();

	CONFIG_VPRG();
	SET_VPRG();

	PULSE_XLAT();

}

void TLC5940_ClockInDC(void) {
	SET_VPRG();
	uint8_t Counter = 0;
	for (;;) {
		if (Counter > TLC5940_N * 96 - 1) {
			PULSE_XLAT();
			break;
		} else {
			if (dcData[Counter])
				SET_SDIN();
			else
				CLR_SDIN();

			PULSE_SCLK();
			Counter++;
		}
	}
	CLR_BLANK();
}

void TLC5940_SetGS_And_GS_PWM(void) {
	uint8_t firstCycleFlag = 0;
	uint16_t GSCLK_Counter = 0;
	uint8_t Channel_Counter = 0;
	uint8_t Bit_Counter = 12;

	if(GET_VPRG()){
		CLR_VPRG();
		firstCycleFlag = 1;
	}

	CLR_BLANK();
	for (;;) {
		if (GSCLK_Counter > 4095) {
			SET_BLANK();
			PULSE_XLAT();

			if (firstCycleFlag) {
				PULSE_SCLK();
				firstCycleFlag = 0;
			}
			break;
		} else {
			if (!(Channel_Counter > 14 && !Bit_Counter)) {
				if(!Bit_Counter){ //if last bit of the channel is being sent
					Channel_Counter++;//increment channel and reset bit counter
					Bit_Counter = 12;
				}

				if (gsData[Channel_Counter] & 1<<(Bit_Counter-1) )
					SET_SDIN();
				else
					CLR_SDIN();

				Bit_Counter--;
				PULSE_SCLK();
			}
		}
		GSCLK_Counter++;
		PULSE_GSCLK();
	}
}

void tlc5940_set(uint8_t channel, uint16_t value)
{
	if (channel < 16)
	 gsData[channel] = value;
}


