#ifndef TLC5940_H
#define TLC5940_H
#ifdef __cplusplus
extern "C" {
#endif
#include <stdint.h>


#define CONFIG_GSCLK() PINSEL1 &= ~(3<<2); IODIR0 |= (1<<17) //config GSCLK for gpio P0.17
#define PULSE_GSCLK()  IOSET0  |=  (1<<17); IOCLR0 |= (1<<17) //pulse GSCLK
#define CLR_GSCLK()		IOCLR0 |= (1<<17)

#define CONFIG_SCLK() PINSEL1 &= ~(3<<6); IODIR0 |= (1<<19) //config SCK for GPIO P0.19
#define PULSE_SCLK()  IOSET0  |=  (1<<19); IOCLR0 |= (1<<19) //pulse SCLK
#define CLR_SCLK() IOCLR0 |= (1<<19)


#define CONFIG_VPRG() PINSEL0 &= ~(3<<26); IODIR0 |= (1<<13) //config VPRG for gpio P0.13
#define SET_VPRG() IOSET0 |= (1<<13)
#define CLR_VPRG() IOCLR0 |= (1<<13)
#define GET_VPRG() IOPIN0 & (1<<13)

#define CONFIG_BLANK() PINSEL1 &= ~(3<<8); IODIR0 |= (1<<20) //config BLANK for gpio P0.20
#define SET_BLANK()  IOSET0 |= (1<<20)
#define CLR_BLANK()  IOCLR0 |= (1<<20)

#define CONFIG_XLAT() PINSEL1 &= ~(3<<0); IODIR0 |= (1<<16) //config XLAT for gpio P0.16
#define SET_XLAT()	  IOSET0 |= (1<<16)
#define CLR_XLAT()	  IOCLR0 |= (1<<16)
#define PULSE_XLAT()  IOSET0  |=  (1<<16); IOCLR0 |= (1<<16)

#define CONFIG_SDIN() PINSEL1 &= ~(3<<4);  IODIR0 |= (1<<18)  //config SDIN for gpio P0.18
#define SET_SDIN() IOSET0 |= (1<<18)
#define CLR_SDIN() IOCLR0 |= (1<<18)

#define FULL_INTENSITY 0x0FFF
#define NO_INTENSITY 0

void TLC5940_SetGS_And_GS_PWM(void); //write gray scale data
void tlc5940_init(); //init pins
void TLC5940_ClockInDC(void); //write dot correction data
void tlc5940_set(uint8_t channel, uint16_t value); //set channel value for write to channel






#ifdef __cplusplus
}
#endif
#endif
